from tkinter import *
from random import randint


fen = Tk() #création de la fenêtre
fen.geometry("1000x600")
fen.resizable(False,False)
fen.title("Styx") #On donne le titre Styx à la fenêtre

#fonctions qui font apparaître le canvas souhaité à la place des autres
def start(): 
	accueil.pack_forget() 
	reco.pack_forget() 
	canvas.pack()
	
def menu():
	reco.pack_forget()
	accueil.pack()

#création des canvas
accueil = Canvas(fen, width=1000, height=600)
canvas = Canvas(fen, width=1000, height=600) #canvas du jeu
reco = Canvas(fen, width=1000, height=600) #canvas pour recommencer
accueil.pack()

#création et placement des boutons et du score

def dead(): #affiche reco si on perd et réinitialise la position des nénuphars dans canvas
	canvas.pack_forget()
	reco.pack()
	l_score.configure(text="score : "+str(frog.score)) #affiche le nouveau score
	frog.not_moved = True
	frog.score = 0
	frog.move(-frog.x + 470, False)
	for nen in nen_list:
		nen_coords = canvas.coords(nen.img)
		if nen_coords[1] == 450:
			canvas.move(nen.img, -nen_coords[0] + 425, 0)
			nen.speed = 0

#création de la classe player
class player:
	def __init__(self, x, y, img, l, h):
		self.x = x
		self.y = y
		self.h = h #hauteur
		self.l = l #largeur
		self.img = img
		self.score = 0
		self.nen = None #nenuphar sur lequel est la grenouille
		self.not_moved = True #le joueur n'a pas encore avancé

	def move(self, dx, moveY): #fonction qui empêche le joueur de sortir des bords de la fenêtre et signale que le joueur a avancé
		if self.x + dx >= 0 and self.x + dx + self.l <= 1000: 
			self.x += dx
			canvas.move(self.img,dx,0)
		if moveY and self.not_moved:
			self.not_moved = False #le joueur a avancé

	def test_nenuphar(self): #si le joueur est sur un nénuphar, on le stocke dans self.nen, sinon le joueur meurt
		for nen in nen_list: 
			n_pos = canvas.coords(nen.img)
			A = point_in_rect(n_pos[0], n_pos[1], 170, 170, self.x, self.y)
			B =	point_in_rect(n_pos[0], n_pos[1], 170, 170, self.x + self.l, self.y)
			C =	point_in_rect(n_pos[0], n_pos[1], 170, 170, self.x, self.y + self.h)
			D =	point_in_rect(n_pos[0], n_pos[1], 170, 170, self.x + self.l, self.y + self.h)
			if A and B and C and D: #si le joueur est sur un nénuphar
				self.nen = nen
				self.score += 10
				return
		self.nen = None
		if not self.not_moved:
			dead()


max_nen_speed = 8 #vitesse max des nénuphars

class nenuphar: 
	def __init__(self, img):
		self.img = img
		self.speed = 0 
		self.dir = 0 #direction de nénuphar 
		self.randomize()
		

	def reverse(self): #inverse la direction
		self.dir *= -1

	def randomize(self): #rend la vitesse des nénuphars aléatoire
		self.speed = randint(4, max_nen_speed)
		nen_pos = canvas.coords(self.img)
		if nen_pos[0] + 75 <= 500:
			self.dir = -1
		else:
			self.dir = 1

def keypress(event): #définit les touches de déplacement de la grenouille
	dy = 0
	moveY = False 
	if event.char == "z": dy = -150 #z = déplacement à l'avant

	if dy != 0: 
		moveY = True
	frog.move(0, moveY)

	for nen in nen_list: #bouge tous les nénuphars dans le sens inverse du déplacement de la grenouille en y
		canvas.move(nen.img, 0, -dy)
		n_coords = canvas.coords(nen.img)
		if n_coords[1] >= 600: #si un nénuphar dépasse le bord inférieur, on le met en haut 
			canvas.move(nen.img, 0, -450)
			nen.randomize()
		
	frog.test_nenuphar()
		
fen.bind("<Key>",keypress) #relie le clavier à la fonction keypress


def deplacement(): 
	for nen in nen_list: #déplace les nénuphars de droite à gauche
		n_coords = canvas.coords(nen.img)
		if n_coords[0] <= 0 or n_coords[0] + 150 >= 1000:
			nen.reverse()
		canvas.move(nen.img, nen.dir * nen.speed, 0)

		if frog.nen == nen: #déplace la grenouille avec le nénuphar sur lequel elle est
			frog.move(nen.dir * nen.speed, False)
	fen.after(20, deplacement)


def point_in_rect(x,y,l,h,X,Y): #fonction qui renvoie True si un objet se trouve à l'intérieur d'un rectangle ou au même endroit
	return (x <= X <= x + l) and (y <= Y <= y + h)

#création des images
img1 = PhotoImage(file = "assise.png") 
img2 = PhotoImage(file = "nenuphar.png")
img3 = PhotoImage(file = "styx.png")
img4 = PhotoImage(file = "perdu.png")
img5 = PhotoImage(file = "jeu.png")

fond = accueil.create_image(0, 0, image=img3, anchor=NW)
jeu = canvas.create_image(0, 0, image=img5, anchor=NW)
perdu = reco.create_image(0, 0, image=img4, anchor=NW)

#création des nénuphars et de la liste des nénuphars
nen_list = []
nen1 = nenuphar(canvas.create_image(425, 450, image=img2, anchor=NW))
nen2 = nenuphar(canvas.create_image(randint(0, 650), 300, image=img2, anchor=NW))
nen3 = nenuphar(canvas.create_image(randint(0, 650), 150, image=img2, anchor=NW))
nen1.speed = 0

nen_list.append(nen1)
nen_list.append(nen2)
nen_list.append(nen3)

frog = player(470, 470, canvas.create_image(470 ,470 , image=img1, anchor=NW), 60, 120)

b_start = Button(accueil, text="commencer :)", padx=26, pady=12, command=start, bg="steelblue")
b_quit = Button(accueil, text="quitter :(",padx=20, pady=12, command=fen.destroy, bg="steelblue")
b_reco = Button(reco, text="recommencer",padx=30, pady=12, command=start)
b_menu = Button(reco, text="revenir au menu",padx=16, pady=12, command=menu)
l_score = Label(reco, text="score : " + str(frog.score))
l_score.place(x=500, y=190, anchor=CENTER)
b_start.place(x=500, y=300, anchor=CENTER)
b_quit.place(x=500, y=355, anchor=CENTER)
b_reco.place(x=500, y=250, anchor=CENTER)
b_menu.place(x=500, y= 310, anchor=CENTER)
#intègre la grenouille à la classe player


deplacement()

fen.mainloop()